{$APPTYPE CONSOLE}

program dining_room;
const
  INFINITY = MaxInt div 2;
var
  c, a: array[1..100] of integer;
  sigma: array[0..1100] of integer;
  n, aa: integer;
  res: integer;
  i, alpha: integer;
begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  assert(not SeekEof(input));
  read(n);
  assert((1 <= n) and (n <= 100));
  assert(not SeekEof(input));
  read(aa);
  assert((1 <= aa) and (aa <= 1000));
  for i := 1 to n do
  begin
    assert(not SeekEof(input));
    read(c[i]);
    assert((1 <= c[i]) and (c[i] <= 500));
    assert(not SeekEof(input));
    read(a[i]);
    assert((1 <= a[i]) and (a[i] <= 100));
  end;
  assert(SeekEof(input));

  sigma[0] := 0;
  for alpha := 1 to aa+100 do
  begin
    sigma[alpha] := INFINITY;
    for i := 1 to n do
    begin
      if (a[i] <= alpha) then
      begin
        if (sigma[alpha-a[i]] + c[i] < sigma[alpha]) then
          sigma[alpha] := sigma[alpha-a[i]] + c[i];
      end;
    end;
  end;

  res := INFINITY;
  for alpha := aa to aa+100 do
  begin
    if (sigma[alpha] < res) then
      res := sigma[alpha];
  end;

  write(res);

  close(input);
  close(output);
end.